unit UTableauVoiture;

{$mode ObjFPC}{$H+}

interface

//importation du module UVoiture
//indispensable pour avoir accès à la structure TVoiture
USES UVoiture;

TYPE
//****************************
//structure tableau de voiture
TTabVoiture = array of TVoiture;

//***************************************************************************
//*** procédures et fonctions de manipulation de la structure TTabVoiture ***

//saisie
procedure saisieTab(var t: TTabVoiture);

//affichage des voitures du tableau
procedure afficherTab(const t: TTabVoiture);

//trier selon la taxe()
procedure trierTab(var t: TTabVoiture);

implementation

//saisie des voitures du tableau
procedure saisieTab(var t: TTabVoiture);
var i: integer;
begin
 for i:= 0 to length(t)-1 do
  //saisie des caractéristiques de la voiture n°i
  saisieVoiture(t[i]);
end;

//affichage des voitures du tableau
procedure afficherTab(const t: TTabVoiture);
var i: integer;
begin
 writeln('Liste des voitures');
 writeln('******************');
 for i:= 0 to length(t)-1 do
  begin
   //affichage des caractéristiques de la voiture n°i
   affichageVoiture(t[i]);
  end;
end;

//trier
procedure trierTab(var t: TTabVoiture);
var aucun_echange :boolean;
    j: integer;
    tmp: TVoiture;
begin
 REPEAT
  aucun_echange:= true;
  for j:= 0 to length(t)-2 do
   begin
    //ce sont les taxes - calculées - qui sont comparées
    if (taxeVoiture(t[j]) > taxeVoiture(t[j+1])) then
     begin
      //mais ce sont bien les voitures qu'on échange de place dans le tableau
      tmp:= t[j];
      t[j]:= t[j+1];
      t[j+1]:= tmp;
      aucun_echange:= false;
     end;
   end;
 UNTIL (aucun_echange = true);
end;

end.

